#ifndef RING_BUFFER_
#define RING_BUFFER_

struct ring_buffer
   {
   void ** data;
   size_t max;
   size_t start;
   size_t count;
   };

struct ring_buffer * ring_buffer_new(size_t const size);
void ring_buffer_delete(struct ring_buffer * rb);
void * ring_buffer_write(struct ring_buffer * rb, void * elem);
void * ring_buffer_read(struct ring_buffer * rb);
size_t ring_buffer_size(struct ring_buffer * rb);

#endif
